/******************************************************************************
 GMMDIServer.cc

	<Description>

	BASE CLASS = public JXMDIServer

	Copyright  1997 by Glenn W. Bach.  All rights reserved.
	
	Base code generated by Codemill v0.1.0

 *****************************************************************************/

#include <GMMDIServer.h>
#include <GMApp.h>

#include <JString.h>

#include <jXGlobals.h>

#include <jDirUtil.h>
#include <jAssert.h>

const JCharacter* kGMSig = "gmail-mdi";

/******************************************************************************
 Constructor

 *****************************************************************************/

GMMDIServer::GMMDIServer
	(
	GMApp* app
	)
	:
	JXMDIServer(kGMSig)
{
	itsApp = app;
}

/******************************************************************************
 Destructor

 *****************************************************************************/

GMMDIServer::~GMMDIServer()
{
}

/******************************************************************************
 HandleMDIRequest

 *****************************************************************************/

void
GMMDIServer::HandleMDIRequest
	(
	const JCharacter* dir,
	const JPtrArray<JString>& argList
	)
{
	JString cwd = JGetCurrentDirectory();
	JChangeDirectory(dir);
	JString base(dir);
	JAppendDirSeparator(&base);
	JSize count = argList.GetElementCount();
	if (count > 1)
		{
		for (JSize i = 2; i <= count; i++)
			{
			JString* mbox = new JString(*(argList.NthElement(i)));
			if (!mbox->BeginsWith("/"))
				{
				mbox->Prepend(base);
				}
			itsApp->OpenMailbox(*mbox);
			}
		}
	else
		{
		itsApp->OpenSystemMailbox();
		}
	JChangeDirectory(cwd);
}
