/******************************************************************************
 GMailPrefsDialog.h

	Interface for the GMailPrefsDialog class

	Copyright @ 1997 by Glenn W. Bach.

 ******************************************************************************/

#ifndef _H_GMailPrefsDialog
#define _H_GMailPrefsDialog

#include <JXDialogDirector.h>

class JXTextButton;
class JXInputField;
class JXTextCheckbox;
class JXStaticText;
class JString;
class JXIntegerInput;

class GMailPrefsDialog : public JXDialogDirector
{
public:

	GMailPrefsDialog(JXDirector* supervisor,
						const JString& inbox,
						const JString& smtp,
						const JString& smtpuser,
						const JString& repltyto,
						const JBoolean showstate,
						const JString& pop,
						const JString& account,
						const JBoolean usePop,
						const JBoolean leave,
						const JBoolean save,
						const JBoolean useAPop,
						const JBoolean autoQuote,
						const JBoolean autoCheck,
						const JInteger minutes,
						const JBoolean showSender,
						const JString& senderString);

	virtual ~GMailPrefsDialog();

	void	GetValues(JString* inbox,
						JString* 	smtp,
						JString* 	smtpuser,
						JString*	replyto,
						JBoolean* 	showstate,
						JString* 	pop,
						JString* 	account,
						JBoolean* 	usePop,
						JBoolean* 	leave,
						JBoolean* 	save,
						JBoolean* 	useAPop,
						JBoolean* 	autoQuote,
						JBoolean* 	autoCheck,
						JInteger*	minutes,
						JBoolean*	showSender,
						JString*	senderString);
	
protected:
	
	virtual void	Receive(JBroadcaster* sender, const Message& message);

private:

// begin JXLayout

    JXTextButton*   itsChooseInboxButton;
    JXInputField*   itsSMTPServerInput;
    JXInputField*   itsPopServerInput;
    JXStaticText*   itsPOPText3;
    JXTextCheckbox* itsUsePopButton;
    JXTextCheckbox* itsLeaveMailButton;
    JXTextCheckbox* itsSavePasswdButton;
    JXInputField*   itsPopAccountInput;
    JXStaticText*   itsPOPText4;
    JXStaticText*   itsInboxText;
    JXTextCheckbox* itsShowStateInTitle;
    JXTextCheckbox* itsAutoQuote;
    JXTextCheckbox* itsUseAPop;
    JXTextCheckbox* itsAutoCheckMail;
    JXIntegerInput* itsCheckMailDelay;
    JXStaticText*   itsPOPText1;
    JXStaticText*   itsPOPText2;
    JXInputField*   itsSMTPUserName;
    JXInputField*   itsReplyToAddress;
    JXTextCheckbox* itsShowSenderString;
    JXInputField*   itsSenderStringInput;
    JXStaticText*   itsSenderText;

// end JXLayout

private:

	void	BuildWindow(const JString& inbox,
						const JString& smtp,
						const JString& smtpuser,
						const JString& repltyto,
						const JBoolean showstate,
						const JString& pop,
						const JString& account,
						const JBoolean usePop,
						const JBoolean leave,
						const JBoolean savepasswd,
						const JBoolean useAPop,
						const JBoolean autoQuote,
						const JBoolean autoCheck,
						const JInteger minutes,
						const JBoolean showSender,
						const JString& senderString);

	void	AdjustForPOP(const JBoolean usePOP);
	void	AdjustForSenderString(const JBoolean showSender);

	// not allowed

	GMailPrefsDialog(const GMailPrefsDialog& source);
	const GMailPrefsDialog& operator=(const GMailPrefsDialog& source);
};

#endif
