/******************************************************************************
 GMessageView.cc

	<Description>

	BASE CLASS = public JXTEBase

	Copyright  1997 by Glenn W. Bach.  All rights reserved.
	
	Base code generated by Codemill v0.1.0

 *****************************************************************************/

//Class Header
#include <GMessageView.h>
#include <GPrefsMgr.h>
#include <GMGlobals.h>

#include <JXColormap.h>
#include <JXDisplay.h>
#include <JXFontManager.h>

#include <JFontStyle.h>
#include <JFontManager.h>

#include <jASCIIConstants.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <iostream.h>
#include <jAssert.h>


/******************************************************************************
 Constructor

 *****************************************************************************/

GMessageView::GMessageView
	(
	JXMenuBar* 			menuBar, 
	JXScrollbarSet* 	scrollbarSet, 
	JXContainer* 		enclosure,
	const HSizingOption	hSizing, 
	const VSizingOption vSizing,
	const JCoordinate 	x, 
	const JCoordinate 	y,
	const JCoordinate 	w, 
	const JCoordinate 	h
	)
	:
   JXSRTextBase(kSelectableText, kFalse, kFalse, scrollbarSet, enclosure, 
   				hSizing, vSizing, x, y, w, h)
{
	GMessageViewX(scrollbarSet, enclosure, hSizing, vSizing, x, y, w, h);
	AppendEditMenu(menuBar, JXMenu::kMacintoshStyle, kFalse, kFalse, kFalse, kFalse);
	AppendSearchMenu(GetSearchDialog(), menuBar, JXMenu::kMacintoshStyle);
	SetAsActiveTextEditor();
}

GMessageView::GMessageView
	(
	JXScrollbarSet* 	scrollbarSet, 
	JXContainer* 		enclosure,
	const HSizingOption	hSizing, 
	const VSizingOption vSizing,
	const JCoordinate 	x, 
	const JCoordinate 	y,
	const JCoordinate 	w, 
	const JCoordinate 	h
	)
	:
   JXSRTextBase(kSelectableText, kFalse, kFalse, scrollbarSet, enclosure, 
   				hSizing, vSizing, x, y, w, h)
{
	GMessageViewX(scrollbarSet, enclosure, hSizing, vSizing, x, y, w, h);
}

void GMessageView::GMessageViewX
	(
	JXScrollbarSet* 	scrollbarSet, 
	JXContainer* 		enclosure,
	const HSizingOption	hSizing, 
	const VSizingOption vSizing,
	const JCoordinate 	x, 
	const JCoordinate 	y,
	const JCoordinate 	w, 
	const JCoordinate 	h
	)
{
	SetBackColor(GetColormap()->GetWhiteColor());
	ShouldAllowDragAndDrop(kTrue);
	SetDefaultFont(GGetPrefsMgr()->GetDefaultMonoFont(), kJDefaultFontSize);
	SetCRMTabCharCount(8);
}

/******************************************************************************
 Destructor

 *****************************************************************************/

GMessageView::~GMessageView()
{
}

/******************************************************************************
 HandleKeyPress

 ******************************************************************************/

void
GMessageView::HandleKeyPress
	(
	const int 				key, 
	const JXKeyModifiers& 	modifiers
	)
{
	if (key == kJUpArrow)
		{
		StripEvents(kTrue);
		}
	else if (key == kJDownArrow)
		{
		StripEvents(kFalse);
		}
	JXSRTextBase::HandleKeyPress(key, modifiers);
}

/******************************************************************************
 StripEvents

 ******************************************************************************/

void
GMessageView::StripEvents
	(
	const JBoolean up
	)
{
	Display* display = GetDisplay()->GetXDisplay();
	JBoolean ok = kTrue;
	while ((XPending(display) != 0) && ok)
		{
		XEvent xEvent;
		XPeekEvent(display, &xEvent);

		if ((xEvent.type == KeyPress) || (xEvent.type == KeyRelease))
			{
			JCharacter buffer[10];
			KeySym keySym;
			JSize charCount =
				XLookupString(const_cast<XKeyEvent*>(&(xEvent.xkey)), buffer, 10, &keySym, NULL);
			if (charCount == 0)
				{
				buffer[0] = '\0';
				}
			if (up && (keySym == XK_Up || keySym == XK_KP_Up))
				{
				XNextEvent(display, &xEvent);
				}
			else if (!up && (keySym == XK_Down || keySym == XK_KP_Down))
				{
				XNextEvent(display, &xEvent);
				}
			else
				{
				ok = kFalse;
				}
			}
		else
			{
			ok = kFalse;
			}
		}
}
