/******************************************************************************
 GOverviewHelpText.cc

	Copyright  1997 by John Lindal. All rights reserved.

 ******************************************************************************/

#include "GHelpText.h"

const JCharacter* kOverviewHelpName  = "GOverviewHelp";
const JCharacter* kOverviewHelpTitle = "Arrow overview";

const JCharacter* kOverviewHelpText =

"<b>Introduction</b> "
"<p> Arrow was designed to be a full-featured, yet easy "
"to use mail program. While currently only in its first stable release, "
"Arrow still has a great deal of functionality, including secure "
"mail via PGP, POP access,  and a spell "
"checker. One unique feature of Arrow is its drag-and-drop functionality. "
"Messages can be dragged from one mail file and moved to another mail file, "
"with each mail file viewed in a separate window. Messages can also be "
"rearranged within one mail file by dragging messages around. Another unique "
"feature of Arrow is the session. Whenever you quit Arrow, the complete "
"state is saved. In other words, it will remember which messages you were "
"viewing, which mail files were opened and what messages you were composing. "
"It will also remember the window sizes and positions for each window."
"<p>"
"Like some other mail programs, Arrow stores a list of you inboxes. I use "
"procmail to filter my mail into several different mail files. Whenever one "
"of Arrow's inboxes receives new mail, Arrow will open the mail file in the "
"form of an inbox icon on the desktop. This performs the same function then "
"that xbiff has in the past, except all you need to do if double-click on "
"the icon, and you'll be able to view the mail in that inbox."
"<p>"
"Arrow was designed such that it could be used in conjunction with command "
"line mail or Pine. For example, I often need to log in remotely and read my "
"mail with only a command line interface. Since arrow leaves the mail files "
"in the original format, this is not a problem. I've even used Pine's "
"address book format for the address book of Arrow, so that if you use Pine "
"and have a large address book, you don't need to do anything to use your "
"addresses in Arrow."
"<p>"
"<b>Editing</b>"
"<p>"
""
"The editor in Arrow is quite useful thanks to the underlying GUI library, "
"JX. For maximum functionality, however, you may need to slightly adjust "
"your window manager's configuration. Fvwm and its descendants, for example, "
"capture a lot of key combinations that it doesn't really need. Some of "
"these can be used by the editor for improved usability. "
""
"<p>"
"A typical Fvwm, Fvwm2, or Fvwm95 configuration includes the following:"
"<p>"
"<pre>"
"# press arrow + control anywhere, and scroll by 1 page "
"Key Left	A	C	Scroll -100 0 "
"Key Right	A	C	Scroll +100 +0 "
"Key Up		A	C	Scroll +0   -100 "
"Key Down	A	C	Scroll +0   +100 "
""
"# press arrow + meta key, and scroll by 1/10 of a page "
"Key Left	A	M	Scroll -10 +0 "
"Key Right	A	M	Scroll +10 +0 "
"Key Up		A	M	Scroll +0   -10 "
"Key Down	A	M	Scroll +0   +10 "
"</pre>"
"<p>"
""
"The upper section scrolls your virtual terminal by a page when you type the "
"control key plus an arrow key, while the lower section scrolls it by 10% "
"when the Alt or Meta key is used. While the former is quite useful, the "
"latter seems rather unimportant. We therefore change the configuration to:"
""
"<p>"
"<pre>"
"# press arrow + control anywhere, and scroll by 1 page "
"Key Left	A	MC	Scroll -100 0 "
"Key Right	A	MC	Scroll +100 +0 "
"Key Up		A	MC	Scroll +0   -100 "
"Key Down	A	MC	Scroll +0   +100 "
""
"# press arrow + meta key, and scroll by 1/10 of a page "
"#Key Left	A	M	Scroll -10 +0 "
"#Key Right	A	M	Scroll +10 +0 "
"#Key Up		A	M	Scroll +0   -10 "
"#Key Down	A	M	Scroll +0   +10 "
"</pre>"
"<p>"
""
"This will change it so that the virtual terminal is scrolled a page when "
"you type control-meta-arrow (meta in this case is synonymous with alt). If "
"this is done, the editor will use control-arrow (left/right) to move the "
"cursor by one word, meta-arrow (left/right) to move to the beginning/end of "
"a line, and meta-arrow (up/down) to move the cursor to the beginning/end of "
"the text.";
