/******************************************************************************
 JSpellChecker.h

	Interface for the JSpellChecker class

	Copyright  1997 by Glenn W. Bach.  All rights reserved.
	
	Base code generated by Codemill v0.1.0

 *****************************************************************************/

#ifndef _H_JSpellChecker
#define _H_JSpellChecker

#include <JBroadcaster.h>
#include <JPtrArray.h>

#include <jTypes.h>

class JTextEditor;
class JXSpellCheckerDialog;
class JInPipeStream;
class JOutPipeStream;
class JString;
class JProcess;

class JSpellChecker : virtual public JBroadcaster
{
public:

	JSpellChecker(JTextEditor* editor);
	virtual ~JSpellChecker();

	void	CheckWords();
	
protected:

	virtual void	Receive(JBroadcaster* sender,
								const JBroadcaster::Message& message);

private:

	JTextEditor*	itsEditor;			// We don't own this
	JIndex			itsCurrentIndex;
	
	JXSpellCheckerDialog*	itsDialog;
	JInPipeStream*			itsIn;
	JOutPipeStream*			itsOut;
	JPtrArray<JString>*		itsWords;
	JProcess*				itsProcess;

private:

	JBoolean	CheckWord(const JString& word);

	// not allowed

	JSpellChecker(const JSpellChecker& source);
	const JSpellChecker& operator=(const JSpellChecker& source);

public:

// Broadcaster messages

	static const JCharacter* kSpellCheckFinished;

	class SpellCheckFinished : public JBroadcaster::Message
		{
		public:

			SpellCheckFinished()
				:
				JBroadcaster::Message(kSpellCheckFinished)
				{ };
		};

};
#endif
